image: golang:1.16.6-alpine3.14

before_script:
  - echo ':before_script'
  - cat /etc/os-release
  - echo 'end :before_script'

stages:
  - test
  - build

# Stage Test:
test-backend:
  stage: test
  script:
    - CGO_ENABLED=0 go test ./... -coverprofile=coverage-report.out
    - go tool cover -html=coverage-report.out -o coverage-report.html
    # This option allows you open a browser and check results directly: go tool cover -html=coverage-report.out
    # You can combine test & cover commands: go test ./... -coverprofile=coverage-report.out && go tool cover -html=coverage-report.out
    - go tool cover -func=coverage-report.out
  artifacts:
    paths:
      - coverage-report.html
    expire_in: 1 days
  coverage: "/\\(statements\\)\\s+\\d+.?\\d+%/"

# Stage Build
build-backend:
    stage: build
    script:
      - go build -o bin/cra-generator -v .
    artifacts:
      paths:
        - bin/cra-generator
      expire_in: 1 days

